#include <graphics.h>
#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include <iostream.h>
#include "scope.h"

const char traco = 3;
int posx;
int posy;

void scope::divisao(int xt, int yt)
{
	// DEFINICAO DE VARIAVEIS LOCAIS
	int xinicial;
	int xfinal;
	int yinicial;
	int yfinal;

	// TRACA CONTORNO DAS DIVISOES
	xinicial=xt-traco;
	yfinal=yt+sizetotal+traco;

	setcolor(DARKGRAY);
	line(xt,yt,xt,yfinal); //ESQUERDA
	line(xt+sizetotal,yt,xt+sizetotal,yfinal);  //DIREITA
	line(xinicial,yt,xt+sizetotal,yt); // ACIMA
	line(xinicial,yt+sizetotal,xt+sizetotal,yt+sizetotal); //ABAIXO

	if (quergrade) {

		xfinal=xt+sizetotal;
		yinicial=yt;

		setcolor(DARKGRAY);
		for (int xpos=xt+size; xpos<xt+sizetotal; xpos+=size)
			line(xpos,yinicial,xpos,yfinal);
		for (int ypos=yt+size; ypos<yt+sizetotal; ypos+=size)
			line(xinicial,ypos,xfinal,ypos);
	}

}

void scope::tracos(void)
{
	int yinicial;
	int xfinal;
	yinicial=ymax-traco;
	xfinal=xmin+traco;
	setcolor(YELLOW);
	for (int xpos=xmin; xpos<xmax; xpos+=size)
		line(xpos,yinicial,xpos,ymax+traco);
	for (int ypos=ymin; ypos<ymax; ypos+=size)
		line(xmin-traco,ypos,xfinal,ypos);
	for (xpos=xmin;xpos<=xmin+xdivs*sizetotal;xpos+=sizetotal)
	{
		setcolor(LIGHTRED);
		line(xpos,ymin+ydivs*sizetotal-traco,xpos,ymin+ydivs*sizetotal+traco+2);
	}
	for (ypos=ymin+ydivs*sizetotal;ypos>=ymin;ypos-=sizetotal)
	{
		setcolor(LIGHTRED);
		line(xmin-traco-2,ypos,xmin+traco,ypos);
	}
}

inline int scope::x(float xg)
{
	return(xmin+(xg-x0)*DELTAX);
}

inline int scope::y(float yg)
{
	return(ymax-(yg-y0)*DELTAY);
}


scope::scope(int xdivst, int ydivst, char quergradet,
	int xmint, int ymint, int sizet)
{
	if (sizet<10)
		{
			cout<<"The size of scope must be greater than 10";
			exit(1);
		};
	xdivs = xdivst;
	ydivs = ydivst;
	quergrade = quergradet;
	xmin=xmint;
	ymin=ymint;
	size=sizet;
	sizetotal = 5*size;
	xmax=xmin+xdivs*sizetotal;
	ymax=ymin+ydivs*sizetotal;
	x0=0;
	y0=0;
	x100=0;
	y100=0;

	int oldcolor=getcolor();

	// Limpa scope
	setfillstyle(SOLID_FILL,BLACK);
	int tela[8] = { xmin,ymin,
									xmax,ymin,
									xmax,ymax,
									xmin,ymax };
	fillpoly(4,tela);

	for (int xpos = xmin; xpos < xmin+xdivs*sizetotal; xpos+=sizetotal)
		for (int ypos = ymin+(ydivs-1)*sizetotal; ypos >= ymin; ypos-=sizetotal)
			divisao(xpos,ypos);

	tracos();

	for (xpos = xmin; xpos <=xmin+xdivs*sizetotal; xpos++)
		{
			oldpixel[xpos].color=getpixel(xpos,ymin);
			oldpixel[xpos].y=ymin;
		}

/*	setfillstyle(EMPTY_FILL,BLACK);
	setcolor(LIGHTCYAN);
	int tela2[8] = { xmin,ymin,
									xmax,ymin,
									xmax,ymax,
									xmin,ymax };
	fillpoly(4,tela);
*/
	setcolor(oldcolor);
}

scope::~scope(void) { }

void scope::escalax(float x0t, float escx, char precisao[5])
{
	int oldcolor=getcolor();
	setcolor(BLACK);
	char msg[30];
	float xgraf=x0t;
	x0=x0t;
	x100=x0+escx*xdivs;
	for (int xpos=xmin;xpos<=xmin+xdivs*sizetotal;xpos+=sizetotal)
		{
			setcolor(BLACK);
			sprintf(msg,precisao,xgraf);
			xgraf+=escx;
			outtextxy(xpos-textwidth(msg)/2, ymin+ydivs*sizetotal+10,
								msg);
		};
	setcolor(oldcolor);
}

void scope::escalay(float y0t, float escy, char precisao[5])
{
	int oldcolor=getcolor();
	setcolor(BLACK);
	char msg[30];
	float ygraf=y0t;
	y0=y0t;
	y100=y0+escy*ydivs;
	for (int ypos=ymin+ydivs*sizetotal;ypos>=ymin;ypos-=sizetotal)
		{
			setcolor(BLACK);
			sprintf(msg,precisao,ygraf);
			ygraf+=escy;
			outtextxy(xmin-textwidth(msg)-10, ypos-textheight(msg)/2,
								msg);
		};
	setcolor(oldcolor);
}

void scope::parametros
	(float xgmin, float escxg, float ygmin, float escyg)
{
	if (int(xgmin)!=0) x0=xgmin;
	if (int(escxg)!=0) x100=x0+xdivs*escxg;
	if (int(ygmin)!=0) y0=ygmin;
	if (int(escyg)!=0) y100=y0+ydivs*escyg;

	DELTAX=(xmax-xmin)/(x100-x0);
	DELTAY=(ymax-ymin)/(y100-y0);
}

void scope::plot(float xg, float yg)
{
	posx=x(xg);
	posy=y(yg);
	putpixel(posx,oldpixel[posx].y,oldpixel[posx].color);
	oldpixel[posx].color=getpixel(posx,posy);
	oldpixel[posx].y=posy;

	putpixel (posx,posy,WHITE);
}

void scope::plotfix(float xg, float yg, int cor)
{
	posx=x(xg);
	posy=y(yg);
	int color = getcolor();
	int Dsize = 4;
	setcolor(cor);
	line(posx-Dsize,posy,posx+Dsize,posy);
	line(posx,posy-Dsize,posx,posy+Dsize);
	setcolor(color);
}